/*
 *  ===============================================================
 *  Department.java: Create academic department objects ...
 *  ===============================================================
 */

package association03;

import java.util.Map;
import java.util.HashMap;

public class Department {
    private int id;
    private String name;

    private Map<String, Student> students;

    public Department() {
       students = new HashMap<String, Student>();
    }
    
    public int getId() {
        return id;
    }
    
    public void setId(int id) {
        this.id = id;
    }
    
    public String getName() {
        return name;
    }
    
    public void setName(String deptName) {
        this.name = deptName;
    }
    
    public void addStudent(Student student) {
        if (!getStudents().containsKey(student.getName())) {
            getStudents().put(student.getName(), student);
            if (student.getDepartment() != null) {
                student.getDepartment().getStudents().remove(student.getName());
            }
            student.setDepartment(this);
        }
    }
    
    public Map<String,Student> getStudents() {
        return students;
    }

    public String toString() {
        return "Department id: " + getId() + 
               ", name: " + getName();
    }
}
