/*
 *  ===============================================================
 *  Department.java; Create simple model of an academic department.
 *  ===============================================================
 */

package association04;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class Department {
   private int id;
   private String name;

   // Setup collection of students ...

   private Collection<Student> students;

   // Constructor method ....
    
   public Department(){
      students = new ArrayList<Student>();
   }

   // Set/get the department Id.
    
   public int getId() {
      return id;
   }
    
   public void setId(int id) {
        this.id = id;
   }

   // Methods to deal with the department name ...
    
   public String getName() {
        return name;
   }
    
   public void setName(String deptName) {
        this.name = deptName;
   }

   // Add a student to department ....

   public void addStudent(Student student) {

      if ( getStudents().contains(student) == false ) {
           getStudents().add(student);
      }

      // Update departments on the student side ....

      if ( student.getDepartments().contains(this) == false ) {
           student.getDepartments().add(this);
      }
   }

   public Collection<Student> getStudents() {
      return students;
   }

   public void setStudent( Collection<Student> students ) {
      this.students = students;
   }

   // Create a String representation for the department ...

   public String toString() {
      String s = "Department: " + name + "\n";

      s = s + "Students: ";
      if ( students.size() == 0 )
         s = s + " none \n";
      else {
         Iterator iterator1 = students.iterator();
         while ( iterator1.hasNext() != false ) {
            Student student = (Student) iterator1.next();
            s = s + student.getName() + " ";
         }
         s = s + "\n";
      }

      return s;
   }
}
