/*
 *  ========================================================================
 *  SimGeography.java: Simulate many-to-many relationships between states
 *                     and the geographical regions to which they belong.
 *  ========================================================================
 */

package association05;

import java.util.List;
 
public class SimGeography {
   public static void main( String[] args ) {

      // Create country objects ...

      State md = new State( "MD" );
      md.setPopulation( 5 );
    
      State fl = new State( "FL" );
      fl.setPopulation( 10 );

      State ca = new State( "CA" );
      ca.setPopulation( 40 );

      State tx = new State( "TX" );
      tx.setPopulation( 30 );

      // Add states to the East Coast Region ...
    
      GeographicalRegion east = new GeographicalRegion();
      east.setName("East Coast");
      east.addState( md );
      east.addState( fl );

      // Add states to the Southern Region ...

      GeographicalRegion south = new GeographicalRegion();
      south.setName("Southern States");
      south.addState( tx );
      south.addState( fl );

      // Print details of state-region assocations ...

      System.out.println( "Part 1: Summary of State/Geographical Region Associations" );
      System.out.println( "=========================================================" );

      System.out.println( md );
      System.out.println( fl );

      // Print details of region-state assocations ...

      System.out.println( "Part 2: Summary of Geographical Region/State Associations" );
      System.out.println( "=========================================================" );

      System.out.println( east );
      System.out.println( south );
  }
}
