/*
 *  =====================================================================================
 *  FilterListOfStrings02.java: Filter list of strings (Java 8 and above).
 *  =====================================================================================
 */

package filter01;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
 
public class FilterListOfStrings02 {
    public static void main(String[] args) {

        System.out.printf("FilterListOfStrings (Java 8 and above) \n");
        System.out.printf("====================================== \n");
        System.out.printf("--- Assemble and print list of colors ... \n");

        List<String> list = new ArrayList<String>();
        list.add( "RED" );
        list.add( "BLUE" );
        list.add( "BLACK" );
        list.add( "GREEN" );
        list.add( "BROWN" );
        list.add( "ORANGE" );

        System.out.println(list);
 
        // Iterate through the list 

        System.out.printf("--- Filter list ... \n");

        String filteredList01 = list.stream()
                                    .filter(entry -> entry.startsWith("B"))
                                    .collect(Collectors.joining(", ", "[", "]"));
 
        System.out.println(filteredList01);

        System.out.printf("--- Filter and convert back to list ... \n");

        List<String> filteredList02 = list.stream()
                                          .filter(entry -> entry.startsWith("B"))
                                          .collect(Collectors.toList());

        System.out.println(filteredList02);

        System.out.printf("====================================== \n");
        System.out.printf("Finished ... \n");
    }
}
