/* 
 *  ===========================================================================
 *  TestPassengerDataModel.java: Exercise passenger data model for the Titanic.
 *                             
 *  Note: Imported file contains data on 887 passengers, which is only a subset
 *  of the 2000+ passengers on the Titanic. 
 * 
 *  Written by: Mark Austin                                          April 2022 
 *  ===========================================================================
 */ 

package filter04;

import java.io.IOException;

public class TestPassengerDataModel {
    public static void main (String [] args ) {
       System.out.printf("Enter TestPassengerDataModel.main() ... \n");
       System.out.printf("=================================== ... \n");

       // Create Weather data model ...

       PassengerDataModel titanic = new PassengerDataModel();
       titanic.setName("Titanic");

       // Load data/titanic.csv into model ...

       try {
          titanic.loadDataFile("data/titanic.csv");
       } catch (IOException e) {
          System.out.printf("Error: data file not found ...\n");
       }

       // Process passenger data model ...

       titanic.process();

       // Print summary of data ...

       System.out.println ( titanic.toString() );

       System.out.printf("================================= ... \n");
       System.out.printf("Finished! ... \n");
    }
}
