/*
 *  ===========================================================================
 *  TestHashMapPoint.java: Create and print (x,y) coordinate point to double
 *  value map.
 *  
 *  Written By: Mark Austin                                         March, 2013
 *  ===========================================================================
 */

package hashmap03;

import java.awt.Point;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class TestHashMapPoint {

   // Print details of (x,y) coordinate point-to-double mapping ...

   private static void printHashMap( Map<Point, Double> map, final String message ) {
      System.out.println( "Begin: " + message );
      System.out.println( "---------------------------------------------" );

      final Iterator iterator = map.keySet().iterator();
      while ( iterator.hasNext() ) {
         final Point    key = (Point) iterator.next();
         final Double value = map.get( key );
 
         System.out.println( key + " " + value.toString() );
      }

      System.out.println( "---------------------------------------------" );
      System.out.println( "End: " + message );
   }

   // Exercise methods in (x,y) coordinate point-to-double mapping ...

   public static void main(String[] args) {

      // Part 01: Create point-to-double hashmap ...

      System.out.println("Part 01: Build simple hashmap<Point,Double>");
      Map<Point, Double> map = new HashMap<Point, Double>();

      // Add data to the hashmap ....

      Point  key01 = new Point(1, 1);
      Double val01 = new Double( 1.0 );
      Point  key02 = new Point(1, 3);
      Double val02 = new Double( 2.0 );
      Point  key03 = new Point(4, 2);
      Double val03 = new Double( 3.0 );
      Point  key04 = new Point(3, 1);
      Double val04 = new Double( 4.0 );

      map.put(key01, val01);
      map.put(key02, val02);
      map.put(key03, val03);
      map.put(key04, val04);

      // Print details of hashmap ...

      printHashMap( map, "Map (x,y) coordinate --> double value" );

      // Part 02: Create point-to-double hashmap ...

      System.out.println("");
      System.out.println("Part 02: Demonstrate that points must be unique .. ");

      // Modify mappings for (1,1) and (1,3) ....

      map.put( new Point(1, 1), new Double( 5.0 ) );
      map.put( new Point(1, 3), new Double( 6.0 ) );

      // Print details of hashmap ...

      printHashMap( map, "Map (x,y) coordinate --> double value" );

   }
}
