/*
 *  ================================================================
 *  Max.java: Specification for builtin function max (x,y)....
 *
 *  Written by: Mark Austin                               June, 2013
 *  ================================================================
 */

package interface01;

import java.lang.Math;

public class Max implements Function {
   double x, y, z;
   int noArgs = 0;

   public Max () {}

   public int getNoArgs() {
      return noArgs;
   }

   public void setValues ( double ... numbers ) {
      noArgs = numbers.length;
      switch ( noArgs ) {
         case 2:
              x = numbers[0];
              y = numbers[1];
              break;
         case 3:
              x = numbers[0];
              y = numbers[1];
              z = numbers[2];
              break;
         default:
              break;
      }
   }

   public String getName() {
      return "Max";
   }

   public double compute() {
      double result = 0.0;

      switch ( noArgs ) {
         case 2:
              System.out.printf("*** Compute Max.compute(%f, %f) ... \n", x, y);
              result = Math.max ( x, y );
              break;
         case 3:
              System.out.printf("*** Compute Max.compute(%f, %f, %f) ... \n", x, y, z);
              result = Math.max ( Math.max ( x, y ), z );
              break;
         default:
              result = 0.0;
              break;
      }

      return result;
   }
}

