/*
 * ======================================================================
 * LinkedHashMap01.java: A linked hashmap maintains the order in which
 * elements are inserted into the map ....
 * ======================================================================
 */

package linkedhashmap01;

import java.util.*; 
  
public class LinkedHashMap01 { 
    public static void main(String a[]) { 

        // Assemble linked hashmap for state abbreviations and their full names ...

        LinkedHashMap<String, String> states = new LinkedHashMap<String, String>(); 

        states.put( "AZ", "Arizona"); 
        states.put( "CO", "Colorado"); 
        states.put( "HI", "Hawaii"); 
        states.put( "MD", "Maryland"); 
        states.put( "VA", "Virginia"); 
        states.put( "WA", "Washington"); 
  
        // Print the elements in same order as they were inserted ...

        System.out.println( states ); 

        // Query various aspects of the linked hashmap ...
  
        System.out.println("--- Size of the map: " + states.size()); 
        System.out.println("--- Is map empty? ==> " + states.isEmpty()); 
        System.out.println("--- Get value for key 'CA': " + states.get("CA")); 

        System.out.println("--- Test: contains key 'AZ'? " +  states.containsKey("AZ")); 
        System.out.println("--- Test: contains key 'PA'? " +  states.containsKey("PA")); 
        System.out.println("--- Contains value 'Virginia' ==> " + states.containsValue( "Virginia" )); 

        // Remove item from map ...

        System.out.println("--- Remove MD from the map ...\n");
        states.remove("MD"); 

        // Print contents of modified map ...

        System.out.println("--- Print contents of modified map ...\n");
        System.out.println( states ); 
    } 
}
