/*
 * ===========================================================================
 * LinkedHashMapExample.java: Model a stock portfolio as a linked hashmap of
 * stocks and their values ...
 * ===========================================================================
 */

package linkedhashmap02;

import java.util.LinkedHashMap;
import java.util.Map;

public class LinkedHashMap02 {
   public static void main(String[] args) {

      // Create map representing (Company, portfolio price) as (key, value) pair

      Map<String, Double> portfolioMap = new LinkedHashMap<String, Double>();
      portfolioMap.put(     "Apple", new Double(230.00));
      portfolioMap.put(      "Sony", new Double( 16.00));
      portfolioMap.put( "Starbucks", new Double( 56.00));
      portfolioMap.put(     "Tesla", new Double(297.00));

      // Display contents of the LinkedHashMap

      System.out.println("Contents of LinkedHashMap: " + portfolioMap );

      // One of the ways of iterating over the map
      // Notice the order of the elements is same as the order of insertion

      System.out.println("--- Traverse map and print contents: ");
      for (String key : portfolioMap.keySet()) {
          System.out.printf("--- %10s, %6.2f ...\n", key, portfolioMap.get(key) );
      }

      // Retrieve value for a particular key

      System.out.println("--- The current portfolio price of Apple is : " + portfolioMap.get("Apple"));

      // Retrieve size of the LinkedHashMap

      System.out.println("--- Size of the LinkedHashMap is : " + portfolioMap.size());

      // Check if the LinkedHashMap is empty?

      System.out.println("--- Is LinkedHashMap empty? : " + portfolioMap.isEmpty());

      // Check whether the Map contains a particular key or value

      System.out.println("--- LinkedHashMap contains Sony as key?   ==> " + portfolioMap.containsKey("Sony"));
      System.out.println("--- LinkedHashMap contains 56.0 as value? ==> " + portfolioMap.containsValue(56.0));
		
      // Let's sell the Apple portfolios (i.e., and remove them from the portfolio) ...

      System.out.printf("--- Remove entry for Apple ...\n");
      portfolioMap.remove("Apple");
      System.out.printf("--- Contents of portfolioMap after removing Apple: %s ...\n", portfolioMap.toString() );

      // Clear contents of the LinkedHashMap

      portfolioMap.clear();
      System.out.println("--- Contents of linkedHashMap after clearing: " + portfolioMap );
   }
}

