/*
 *  ================================================================
 *  Max.java: Specification for builtin function max (x,y)....
 *
 *  Written by: Mark Austin                               June, 2013
 *  ================================================================
 */

package symbol02.datatypes;

import java.lang.Math;

public class Max implements Function {
   double a, b, c, d;
   int noArgs = 0;

   public Max () {}

   public int getNoArgs() {
      return noArgs;
   }

   public void setValues ( double ... numbers ) {
      noArgs = numbers.length;
      switch ( noArgs ) {
         case 2:
              a = numbers[0];
              b = numbers[1];
              break;
         case 3:
              a = numbers[0];
              b = numbers[1];
              c = numbers[2];
              break;
         case 4:
              a = numbers[0];
              b = numbers[1];
              c = numbers[2];
              d = numbers[3];
         default:
              break;
      }
   }

   public String getName() {
      return "Max";
   }

   public double compute() {
      double result = 0.0;

      switch ( noArgs ) {
         case 2:
              System.out.printf("*** Compute Max.compute(%f, %f) ... \n", a, b);
              result = Math.max ( a, b );
              break;
         case 3:
              System.out.printf("*** Compute Max.compute(%f, %f, %f) ... \n", a, b, c);
              result = Math.max ( Math.max ( a, b ), c );
              break;
         case 4:
              System.out.printf("*** Compute Max.compute(%f, %f, %f %f) ... \n", a, b, c, d);
              result = Math.max ( Math.max ( a, b ), Math.max ( c, d) );
              break;
         default:
              result = 0.0;
              break;
      }

      return result;
   }

   // String representation of Max() function ...

   public String toString() {
      StringBuffer buf = new StringBuffer();
      buf.append( String.format("Max() function : noArgs = %2d\n", noArgs ) );
      return buf.toString();
   }

}

